/* 
 * kekse23.de RCUSB
 * Copyright (c) 2017, Nicholas Regitz
 * 
 * Diese Datei ist Lizensiert unter der Creative Commons 4.0 CC BY-NC-SA
 * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode
 */

#include <Joystick.h>
#include "AVRPort23.h"

#define CHAN1 D,1
#define _INT1 1
#define CHAN2 D,0
#define _INT2 0
#define RXLED B,0
#define TXLED D,5

Joystick_ Joystick(JOYSTICK_DEFAULT_REPORT_ID,JOYSTICK_TYPE_GAMEPAD,
	0, 0,                 // Button Count, Hat Switch Count
	false, false, false,	// X, Y, Z
	false, false, false,	// Rx, Ry, Rz
	false, false,		      // Rudder, Throttle
	true, false, true);		// Accelerator, Brake, Steering

void setup()
{
  portMode(CHAN1, INPUT, HIGH);
  portMode(CHAN2, INPUT, HIGH);
  portMode(RXLED, OUTPUT, LOW);
  portMode(TXLED, OUTPUT, LOW);
  
	Joystick.begin();
	Joystick.setSteeringRange(2250, 750);
	Joystick.setAcceleratorRange(2250, 750);
	
  attachInterrupt(_INT1, isr1, CHANGE);
  attachInterrupt(_INT2, isr2, CHANGE);
}

volatile unsigned long Time1;
volatile unsigned long Time2;
volatile unsigned int Value1;
volatile unsigned int Value2;
volatile bool Val1Changed;
volatile bool Val2Changed;
unsigned int NewValue1;
unsigned int NewValue2;

void loop()
{ 
  if (micros() > Time1 + 24000) portWrite(RXLED, LOW);
  else portWrite(RXLED, HIGH);

  if (micros() > Time2 + 24000) portWrite(TXLED, LOW);
  else portWrite(TXLED, HIGH);

  if (Val1Changed)
  {
    NewValue1 = (NewValue1+Value1)/2;
    Joystick.setAccelerator(NewValue1);
    Val1Changed = false;
  }

  if (Val2Changed)
  {
    NewValue2 = (NewValue2+Value2)/2;
    Joystick.setSteering(NewValue2);
    Val2Changed = false;
  }
  
  delay(8);
}

void isr1()
{
  if (portRead(CHAN1)) Time1 = micros();
  else if (micros() > Time1)
  {
    Value1 = (Value1+(micros()-Time1))/2;
    Val1Changed = true;
  }
}

void isr2()
{
  if (portRead(CHAN2)) Time2 = micros();
  else if (micros() > Time2)
  {
    Value2 = (Value2+(micros()-Time2))/2;
    Val2Changed = true;
  }
}
